#include "include/config.h"

#if defined(STACK_USE_TELEMETRY_SERVER)
#include "net/include/stacktsk.h"
#include "net/include/telemetry_server.h"
#include "net/include/tcp.h"
#include "net/include/tick.h"

/******************************************************************************
 * Specific types and structures definitions for this module                  *
 ******************************************************************************/
typedef enum _SM_TELEMETRY
{
    SM_TELEMETRY_NOT_CONNECTED,
    SM_TELEMETRY_CONNECTED,
	SM_TELEMETRY_SENT
} SM_TELEMETRY;

#define TELEMETRY_PORT (7777u)
static TCP_SOCKET TelemetrySocket;
static SM_TELEMETRY smTelemetry;                   // telemetry server FSM state

char szResponse[64];
char* pMsg;

void TelemetryServerInit(void)
{
	szResponse[0] = 0;
	TelemetrySocket = TCPListen(TELEMETRY_PORT);
    smTelemetry = SM_TELEMETRY_NOT_CONNECTED;
}

BOOL TelemetryServer(void)
{
    BYTE v;
    TICK currentTick;

    if ( !TCPIsConnected(TelemetrySocket) )
    {
        smTelemetry = SM_TELEMETRY_NOT_CONNECTED;
        return TRUE;
    }
	if (smTelemetry == SM_TELEMETRY_NOT_CONNECTED)
		smTelemetry = SM_TELEMETRY_CONNECTED;	

    switch (smTelemetry) 
	{
	case SM_TELEMETRY_CONNECTED:	
		if(TCPIsPutReady(TelemetrySocket))
		{
	       	pMsg = szResponse;
	           
	       	while( (v = *pMsg++) )
	       	{
	           TCPPut(TelemetrySocket, v);
	       	}
	       	TCPFlush(TelemetrySocket);
			smTelemetry = SM_TELEMETRY_SENT;
		}
		break;
	case SM_TELEMETRY_SENT:
        if ( TCPIsPutReady(TelemetrySocket) )
        {
	        TCPDisconnect(TelemetrySocket);
			smTelemetry == SM_TELEMETRY_NOT_CONNECTED;
        }
        break;		
	default:
		break;
	}
	return TRUE;
}

#endif  // STACK_USE_TELEMETRY_SERVER
